Subject: Re: Editing GSoC Project Ideas

From: Phillip Wood <[email-masked]>
Date: Wed, 4 Mar 2026 15:56:33 +0000

Hi Kaartic

On 02/03/2026 18:03, Kaartic Sivaraam wrote:
> +Cc Stolee
> 
> Hi Phillip,
> 
> On 02/03/26 03:48, Christian Couder wrote:
>>
>> On Sun, Mar 1, 2026 at 3:26 PM Phillip Wood 
>> <[email-masked]> wrote:
>>>
>>> I'd be very grateful if someone with write access could please update
>>> the description of "Refactoring in order to reduce Git’s global state"
>>> [1] to stop recommending moving settings from `environment.c` into
>>> `struct repository_settings`. That struct was originally added to hold
>>> config settings that were already lazily parsed. We've had a number of
>>> submissions that move eagerly parsed config settings into that struct
>>> where an invalid config setting causes git to start dying in unexpected
>>> places when the lazy parsing fails.
>>
>> Yes, we should definitely update the description. Thanks for telling
>> us about this.
>>
> 
> Indeed. Thank you for the suggestion. We've tried to tweak the 
> description accordingly. Kindly check and let us know if it still needs 
> any tweaks:
> 
>    https://git.github.io/SoC-2026-Ideas/

Thanks for updating that, it is certainly much clearer.

>>> I haven't been following Stolee's work [3] on "git conifg list --type"
>>> closely but I think it introduces some functions to parse config
>>> settings gently. Those functions might enable us to parse some config
>>> settings lazy where the functions using the lazily parsed settings are
>>> already set up to return a error. Doing that would require careful
>>> analysis and should not be a blanket recommendation.
>>
>> I haven't followed Stolee's work either, but I will take a look.
>> Thanks for the pointer.
>>
> 
> I've not yet mentioned stolee's work in the tweak as it is a work in 
> progress. I'll leave it for a future enhancement in case it is really 
> worth mentioning the same.

That sounds sensible as none of us have actually thought through if it 
is useful yet.

>> In the meantime, if you have concrete suggestions for change you can
>> submit one or more PRs to the https://github.com/git/git.github.io/
>> repo.
>>
> 
> Just to add to this, any patches via mailing-list are also welcome if 
> that's preferred :-)

Thanks I'll bear that in mind

Phillip